Hex Artifact Content

Artifact 0f3c234f4e15b9e39827f9c4d7c75f6a618747a1:


0000: 23 21 20 2f 62 69 6e 2f 62 61 73 68 0a 0a 69 66  #! /bin/bash..if
0010: 20 5b 20 21 20 2d 66 20 27 62 75 69 6c 64 2e 73   [ ! -f 'build.s
0020: 68 27 20 5d 3b 20 74 68 65 6e 0a 09 65 63 68 6f  h' ]; then..echo
0030: 20 27 45 52 52 4f 52 3a 20 54 68 69 73 20 73 63   'ERROR: This sc
0040: 72 69 70 74 20 6d 75 73 74 20 62 65 20 72 75 6e  ript must be run
0050: 20 66 72 6f 6d 20 74 68 65 20 64 69 72 65 63 74   from the direct
0060: 6f 72 79 20 69 74 20 69 73 20 69 6e 27 20 3e 26  ory it is in' >&
0070: 32 0a 0a 09 65 78 69 74 20 31 0a 66 69 0a 69 66  2...exit 1.fi.if
0080: 20 5b 20 2d 7a 20 22 24 7b 54 43 4c 56 45 52 53   [ -z "${TCLVERS
0090: 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 65 63 68 6f  }" ]; then..echo
00a0: 20 27 45 52 52 4f 52 3a 20 54 68 65 20 54 43 4c   'ERROR: The TCL
00b0: 56 45 52 53 20 65 6e 76 69 72 6f 6e 6d 65 6e 74  VERS environment
00c0: 20 76 61 72 69 61 62 6c 65 20 69 73 20 6e 6f 74   variable is not
00d0: 20 73 65 74 27 20 3e 26 32 0a 0a 09 65 78 69 74   set' >&2...exit
00e0: 20 31 0a 66 69 0a 0a 53 52 43 3d 22 73 72 63 2f   1.fi..SRC="src/
00f0: 74 63 6c 24 7b 54 43 4c 56 45 52 53 7d 2e 74 61  tcl${TCLVERS}.ta
0100: 72 2e 67 7a 22 0a 53 52 43 55 52 4c 3d 22 68 74  r.gz".SRCURL="ht
0110: 74 70 3a 2f 2f 70 72 64 6f 77 6e 6c 6f 61 64 73  tp://prdownloads
0120: 2e 73 6f 75 72 63 65 66 6f 72 67 65 2e 6e 65 74  .sourceforge.net
0130: 2f 74 63 6c 2f 74 63 6c 24 7b 54 43 4c 56 45 52  /tcl/tcl${TCLVER
0140: 53 7d 2d 73 72 63 2e 74 61 72 2e 67 7a 22 0a 42  S}-src.tar.gz".B
0150: 55 49 4c 44 44 49 52 3d 22 24 28 70 77 64 29 2f  UILDDIR="$(pwd)/
0160: 62 75 69 6c 64 2f 74 63 6c 24 7b 54 43 4c 56 45  build/tcl${TCLVE
0170: 52 53 7d 22 0a 4f 55 54 44 49 52 3d 22 24 28 70  RS}".OUTDIR="$(p
0180: 77 64 29 2f 6f 75 74 22 0a 49 4e 53 54 44 49 52  wd)/out".INSTDIR
0190: 3d 22 24 28 70 77 64 29 2f 69 6e 73 74 22 0a 50  ="$(pwd)/inst".P
01a0: 41 54 43 48 53 43 52 49 50 54 44 49 52 3d 22 24  ATCHSCRIPTDIR="$
01b0: 28 70 77 64 29 2f 70 61 74 63 68 73 63 72 69 70  (pwd)/patchscrip
01c0: 74 73 22 0a 65 78 70 6f 72 74 20 53 52 43 20 53  ts".export SRC S
01d0: 52 43 55 52 4c 20 42 55 49 4c 44 44 49 52 20 4f  RCURL BUILDDIR O
01e0: 55 54 44 49 52 20 49 4e 53 54 44 49 52 20 50 41  UTDIR INSTDIR PA
01f0: 54 43 48 53 43 52 49 50 54 44 49 52 0a 0a 72 6d  TCHSCRIPTDIR..rm
0200: 20 2d 72 66 20 27 62 75 69 6c 64 27 20 27 6f 75   -rf 'build' 'ou
0210: 74 27 20 27 69 6e 73 74 27 0a 6d 6b 64 69 72 20  t' 'inst'.mkdir 
0220: 27 62 75 69 6c 64 27 20 27 6f 75 74 27 20 27 69  'build' 'out' 'i
0230: 6e 73 74 27 20 7c 7c 20 65 78 69 74 20 31 0a 0a  nst' || exit 1..
0240: 69 66 20 5b 20 21 20 2d 66 20 22 24 7b 53 52 43  if [ ! -f "${SRC
0250: 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 6d 6b 64 69  }" ]; then..mkdi
0260: 72 20 27 73 72 63 27 20 3e 2f 64 65 76 2f 6e 75  r 'src' >/dev/nu
0270: 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 0a 0a  ll 2>/dev/null..
0280: 09 69 66 20 65 63 68 6f 20 22 24 7b 54 43 4c 56  .if echo "${TCLV
0290: 45 52 53 7d 22 20 7c 20 67 72 65 70 20 27 5e 63  ERS}" | grep '^c
02a0: 76 73 5f 27 20 3e 2f 64 65 76 2f 6e 75 6c 6c 3b  vs_' >/dev/null;
02b0: 20 74 68 65 6e 0a 09 09 43 56 53 54 41 47 3d 24   then...CVSTAG=$
02c0: 28 65 63 68 6f 20 22 24 7b 54 43 4c 56 45 52 53  (echo "${TCLVERS
02d0: 7d 22 20 7c 20 73 65 64 20 27 73 2f 5e 63 76 73  }" | sed 's/^cvs
02e0: 5f 2f 2f 67 27 29 0a 09 09 65 78 70 6f 72 74 20  _//g')...export 
02f0: 43 56 53 54 41 47 0a 0a 09 09 28 0a 09 09 09 63  CVSTAG....(....c
0300: 64 20 73 72 63 20 7c 7c 20 65 78 69 74 20 31 0a  d src || exit 1.
0310: 0a 09 09 09 63 76 73 20 2d 7a 33 20 2d 64 3a 70  ....cvs -z3 -d:p
0320: 73 65 72 76 65 72 3a 61 6e 6f 6e 79 6d 6f 75 73  server:anonymous
0330: 40 74 63 6c 2e 63 76 73 2e 73 6f 75 72 63 65 66  @tcl.cvs.sourcef
0340: 6f 72 67 65 2e 6e 65 74 3a 2f 63 76 73 72 6f 6f  orge.net:/cvsroo
0350: 74 2f 74 63 6c 20 63 6f 20 2d 72 20 22 24 7b 43  t/tcl co -r "${C
0360: 56 53 54 41 47 7d 22 20 2d 50 20 74 63 6c 0a 0a  VSTAG}" -P tcl..
0370: 09 09 09 6d 76 20 74 63 6c 20 22 74 63 6c 24 7b  ...mv tcl "tcl${
0380: 54 43 4c 56 45 52 53 7d 22 0a 0a 09 09 09 74 61  TCLVERS}".....ta
0390: 72 20 2d 63 66 20 2d 20 22 74 63 6c 24 7b 54 43  r -cf - "tcl${TC
03a0: 4c 56 45 52 53 7d 22 20 7c 20 67 7a 69 70 20 2d  LVERS}" | gzip -
03b0: 63 20 3e 20 22 2e 2e 2f 24 7b 53 52 43 7d 22 0a  c > "../${SRC}".
03c0: 09 09 29 0a 09 65 6c 73 65 0a 09 09 72 6d 20 2d  ..)..else...rm -
03d0: 66 20 22 24 7b 53 52 43 7d 2e 74 6d 70 22 0a 09  f "${SRC}.tmp"..
03e0: 09 77 67 65 74 20 2d 4f 20 22 24 7b 53 52 43 7d  .wget -O "${SRC}
03f0: 2e 74 6d 70 22 20 22 24 7b 53 52 43 55 52 4c 7d  .tmp" "${SRCURL}
0400: 22 20 7c 7c 20 65 78 69 74 20 31 0a 09 09 6d 76  " || exit 1...mv
0410: 20 22 24 7b 53 52 43 7d 2e 74 6d 70 22 20 22 24   "${SRC}.tmp" "$
0420: 7b 53 52 43 7d 22 0a 09 66 69 0a 66 69 0a 0a 28  {SRC}"..fi.fi..(
0430: 0a 09 63 64 20 27 62 75 69 6c 64 27 20 7c 7c 20  ..cd 'build' || 
0440: 65 78 69 74 20 31 0a 0a 09 69 66 20 5b 20 21 20  exit 1...if [ ! 
0450: 2d 64 20 27 2e 2e 2f 62 75 69 6c 64 73 72 63 27  -d '../buildsrc'
0460: 20 5d 3b 20 74 68 65 6e 0a 09 09 67 7a 69 70 20   ]; then...gzip 
0470: 2d 64 63 20 22 2e 2e 2f 24 7b 53 52 43 7d 22 20  -dc "../${SRC}" 
0480: 7c 20 74 61 72 20 2d 78 66 20 2d 0a 09 65 6c 73  | tar -xf -..els
0490: 65 0a 09 09 63 70 20 2d 72 70 20 2e 2e 2f 62 75  e...cp -rp ../bu
04a0: 69 6c 64 73 72 63 2f 2a 20 27 2e 2f 27 0a 09 66  ildsrc/* './'..f
04b0: 69 0a 0a 09 63 64 20 22 24 7b 42 55 49 4c 44 44  i...cd "${BUILDD
04c0: 49 52 7d 22 20 7c 7c 20 65 78 69 74 20 31 0a 0a  IR}" || exit 1..
04d0: 09 23 20 41 70 70 6c 79 20 70 61 74 63 68 20 73  .# Apply patch s
04e0: 63 72 69 70 74 73 20 69 66 20 6e 65 65 64 65 64  cripts if needed
04f0: 0a 09 66 6f 72 20 70 61 74 63 68 73 63 72 69 70  ..for patchscrip
0500: 74 20 69 6e 20 22 24 7b 50 41 54 43 48 53 43 52  t in "${PATCHSCR
0510: 49 50 54 44 49 52 7d 22 2f 2a 2e 73 68 3b 20 64  IPTDIR}"/*.sh; d
0520: 6f 0a 09 09 69 66 20 5b 20 2d 66 20 22 24 7b 70  o...if [ -f "${p
0530: 61 74 63 68 73 63 72 69 70 74 7d 22 20 5d 3b 20  atchscript}" ]; 
0540: 74 68 65 6e 0a 09 09 09 65 63 68 6f 20 22 52 75  then....echo "Ru
0550: 6e 6e 69 6e 67 20 70 61 74 63 68 20 73 63 72 69  nning patch scri
0560: 70 74 3a 20 24 7b 70 61 74 63 68 73 63 72 69 70  pt: ${patchscrip
0570: 74 7d 22 0a 0a 09 09 09 28 0a 09 09 09 09 2e 20  t}".....(...... 
0580: 22 24 7b 70 61 74 63 68 73 63 72 69 70 74 7d 22  "${patchscript}"
0590: 0a 09 09 09 29 0a 09 09 66 69 0a 09 64 6f 6e 65  ....)...fi..done
05a0: 0a 0a 09 23 20 50 61 74 63 68 20 57 69 6e 33 32  ...# Patch Win32
05b0: 20 62 75 69 6c 64 73 20 74 6f 20 61 6c 77 61 79   builds to alway
05c0: 73 20 70 72 6f 76 69 64 65 20 44 6c 6c 4d 61 69  s provide DllMai
05d0: 6e 20 69 66 20 77 65 20 61 72 65 20 62 75 69 6c  n if we are buil
05e0: 64 69 6e 67 20 4b 69 74 44 4c 4c 0a 09 69 66 20  ding KitDLL..if 
05f0: 5b 20 22 24 7b 4b 49 54 54 41 52 47 45 54 7d 22  [ "${KITTARGET}"
0600: 20 3d 20 22 6b 69 74 64 6c 6c 22 20 5d 3b 20 74   = "kitdll" ]; t
0610: 68 65 6e 0a 09 09 23 23 20 44 6c 6c 4d 61 69 6e  hen...## DllMain
0620: 20 69 73 20 6e 65 65 64 65 64 20 77 68 65 6e 20   is needed when 
0630: 62 75 69 6c 64 69 6e 67 20 4b 69 74 44 4c 4c 0a  building KitDLL.
0640: 09 09 66 6f 72 20 66 69 6c 65 74 6f 70 61 74 63  ..for filetopatc
0650: 68 20 69 6e 20 77 69 6e 2f 74 63 6c 57 69 6e 33  h in win/tclWin3
0660: 32 44 6c 6c 2e 63 20 77 69 6e 2f 74 63 6c 57 69  2Dll.c win/tclWi
0670: 6e 49 6e 69 74 2e 63 3b 20 64 6f 0a 09 09 09 65  nInit.c; do....e
0680: 63 68 6f 20 22 55 6e 64 65 66 69 6e 69 6e 67 20  cho "Undefining 
0690: 53 54 41 54 49 43 5f 42 55 49 4c 44 20 69 6e 20  STATIC_BUILD in 
06a0: 5c 22 24 7b 66 69 6c 65 74 6f 70 61 74 63 68 7d  \"${filetopatch}
06b0: 5c 22 22 0a 0a 09 09 09 73 65 64 20 27 73 40 53  \"".....sed 's@S
06c0: 54 41 54 49 43 5f 42 55 49 4c 44 40 4e 45 56 45  TATIC_BUILD@NEVE
06d0: 52 5f 53 54 41 54 49 43 5f 42 55 49 4c 44 40 67  R_STATIC_BUILD@g
06e0: 27 20 22 24 7b 66 69 6c 65 74 6f 70 61 74 63 68  ' "${filetopatch
06f0: 7d 22 20 3e 20 22 24 7b 66 69 6c 65 74 6f 70 61  }" > "${filetopa
0700: 74 63 68 7d 2e 6e 65 77 22 20 26 26 20 63 61 74  tch}.new" && cat
0710: 20 22 24 7b 66 69 6c 65 74 6f 70 61 74 63 68 7d   "${filetopatch}
0720: 2e 6e 65 77 22 20 3e 20 22 24 7b 66 69 6c 65 74  .new" > "${filet
0730: 6f 70 61 74 63 68 7d 22 0a 09 09 09 72 6d 20 2d  opatch}"....rm -
0740: 66 20 22 24 7b 66 69 6c 65 74 6f 70 61 74 63 68  f "${filetopatch
0750: 7d 2e 6e 65 77 22 0a 09 09 64 6f 6e 65 0a 09 66  }.new"...done..f
0760: 69 0a 0a 09 66 6f 72 20 64 69 72 20 69 6e 20 75  i...for dir in u
0770: 6e 69 78 20 77 69 6e 20 6d 61 63 6f 73 78 20 5f  nix win macosx _
0780: 5f 66 61 69 6c 5f 5f 3b 20 64 6f 0a 09 09 69 66  _fail__; do...if
0790: 20 5b 20 22 24 7b 64 69 72 7d 22 20 3d 20 22 5f   [ "${dir}" = "_
07a0: 5f 66 61 69 6c 5f 5f 22 20 5d 3b 20 74 68 65 6e  _fail__" ]; then
07b0: 0a 09 09 09 23 20 49 66 20 77 65 20 68 61 76 65  ....# If we have
07c0: 6e 27 74 20 66 69 67 75 72 65 64 20 6f 75 74 20  n't figured out 
07d0: 68 6f 77 20 74 6f 20 62 75 69 6c 64 20 69 74 2c  how to build it,
07e0: 20 72 65 6a 65 63 74 2e 0a 0a 09 09 09 65 78 69   reject......exi
07f0: 74 20 31 0a 09 09 66 69 0a 0a 09 09 23 20 52 65  t 1...fi....# Re
0800: 6d 6f 76 65 20 70 72 65 76 69 6f 75 73 20 64 69  move previous di
0810: 72 65 63 74 6f 72 79 27 73 20 22 74 63 6c 43 6f  rectory's "tclCo
0820: 6e 66 69 67 2e 73 68 22 20 69 66 20 66 6f 75 6e  nfig.sh" if foun
0830: 64 0a 09 09 72 6d 20 2d 66 20 27 74 63 6c 43 6f  d...rm -f 'tclCo
0840: 6e 66 69 67 2e 73 68 27 0a 0a 09 09 63 64 20 22  nfig.sh'....cd "
0850: 24 7b 42 55 49 4c 44 44 49 52 7d 2f 24 7b 64 69  ${BUILDDIR}/${di
0860: 72 7d 22 20 7c 7c 20 65 78 69 74 20 31 0a 0a 09  r}" || exit 1...
0870: 09 65 63 68 6f 20 22 52 75 6e 6e 69 6e 67 3a 20  .echo "Running: 
0880: 2e 2f 63 6f 6e 66 69 67 75 72 65 20 2d 2d 64 69  ./configure --di
0890: 73 61 62 6c 65 2d 73 68 61 72 65 64 20 2d 2d 77  sable-shared --w
08a0: 69 74 68 2d 65 6e 63 6f 64 69 6e 67 3d 75 74 66  ith-encoding=utf
08b0: 2d 38 20 2d 2d 70 72 65 66 69 78 3d 5c 22 24 7b  -8 --prefix=\"${
08c0: 49 4e 53 54 44 49 52 7d 5c 22 20 24 7b 43 4f 4e  INSTDIR}\" ${CON
08d0: 46 49 47 55 52 45 45 58 54 52 41 7d 22 0a 09 09  FIGUREEXTRA}"...
08e0: 2e 2f 63 6f 6e 66 69 67 75 72 65 20 2d 2d 64 69  ./configure --di
08f0: 73 61 62 6c 65 2d 73 68 61 72 65 64 20 2d 2d 77  sable-shared --w
0900: 69 74 68 2d 65 6e 63 6f 64 69 6e 67 3d 75 74 66  ith-encoding=utf
0910: 2d 38 20 2d 2d 70 72 65 66 69 78 3d 22 24 7b 49  -8 --prefix="${I
0920: 4e 53 54 44 49 52 7d 22 20 24 7b 43 4f 4e 46 49  NSTDIR}" ${CONFI
0930: 47 55 52 45 45 58 54 52 41 7d 0a 0a 09 09 65 63  GUREEXTRA}....ec
0940: 68 6f 20 22 52 75 6e 6e 69 6e 67 3a 20 24 7b 4d  ho "Running: ${M
0950: 41 4b 45 3a 2d 6d 61 6b 65 7d 22 0a 09 09 24 7b  AKE:-make}"...${
0960: 4d 41 4b 45 3a 2d 6d 61 6b 65 7d 20 7c 7c 20 63  MAKE:-make} || c
0970: 6f 6e 74 69 6e 75 65 0a 0a 09 09 65 63 68 6f 20  ontinue....echo 
0980: 22 52 75 6e 6e 69 6e 67 3a 20 24 7b 4d 41 4b 45  "Running: ${MAKE
0990: 3a 2d 6d 61 6b 65 7d 20 69 6e 73 74 61 6c 6c 22  :-make} install"
09a0: 0a 09 09 24 7b 4d 41 4b 45 3a 2d 6d 61 6b 65 7d  ...${MAKE:-make}
09b0: 20 69 6e 73 74 61 6c 6c 20 7c 7c 20 28 0a 09 09   install || (...
09c0: 09 23 20 57 6f 72 6b 20 77 69 74 68 20 54 63 6c  .# Work with Tcl
09d0: 20 38 2e 36 2e 78 27 73 20 54 43 4c 53 48 5f 4e   8.6.x's TCLSH_N
09e0: 41 54 49 56 45 20 73 6f 6c 75 74 69 6f 6e 20 66  ATIVE solution f
09f0: 6f 72 0a 09 09 09 23 20 63 72 6f 73 73 2d 63 6f  or....# cross-co
0a00: 6d 70 69 6c 65 20 69 6e 73 74 61 6c 6c 73 0a 0a  mpile installs..
0a10: 09 09 09 65 63 68 6f 20 22 52 75 6e 6e 69 6e 67  ...echo "Running
0a20: 3a 20 24 7b 4d 41 4b 45 3a 2d 6d 61 6b 65 7d 20  : ${MAKE:-make} 
0a30: 69 6e 73 74 61 6c 6c 20 54 43 4c 53 48 5f 4e 41  install TCLSH_NA
0a40: 54 49 56 45 3d 5c 22 24 7b 54 43 4c 4b 49 54 3a  TIVE=\"${TCLKIT:
0a50: 2d 74 63 6c 6b 69 74 7d 5c 22 22 0a 09 09 09 24  -tclkit}\""....$
0a60: 7b 4d 41 4b 45 3a 2d 6d 61 6b 65 7d 20 69 6e 73  {MAKE:-make} ins
0a70: 74 61 6c 6c 20 54 43 4c 53 48 5f 4e 41 54 49 56  tall TCLSH_NATIV
0a80: 45 3d 22 24 7b 54 43 4c 4b 49 54 3a 2d 74 63 6c  E="${TCLKIT:-tcl
0a90: 6b 69 74 7d 22 0a 09 09 29 20 7c 7c 20 28 0a 09  kit}"...) || (..
0aa0: 09 09 23 20 4d 61 6b 65 20 69 6e 73 74 61 6c 6c  ..# Make install
0ab0: 20 63 61 6e 20 66 61 69 6c 20 69 66 20 63 72 6f   can fail if cro
0ac0: 73 73 2d 63 6f 6d 70 69 6c 69 6e 67 20 75 73 69  ss-compiling usi
0ad0: 6e 67 20 54 63 6c 20 38 2e 35 2e 78 0a 09 09 09  ng Tcl 8.5.x....
0ae0: 23 20 62 65 63 61 75 73 65 20 74 68 65 20 4d 61  # because the Ma
0af0: 6b 65 66 69 6c 65 20 63 61 6c 6c 73 20 22 24 28  kefile calls "$(
0b00: 54 43 4c 53 48 29 22 2e 20 20 57 65 20 63 61 6e  TCLSH)".  We can
0b10: 27 74 20 73 69 6d 70 6c 79 0a 09 09 09 23 20 72  't simply....# r
0b20: 65 64 65 66 69 6e 65 20 54 43 4c 53 48 20 62 65  edefine TCLSH be
0b30: 63 61 75 73 65 20 69 74 20 61 6c 73 6f 20 75 73  cause it also us
0b40: 65 73 20 54 43 4c 53 48 20 61 73 20 61 20 62 75  es TCLSH as a bu
0b50: 69 6c 64 20 74 61 72 67 65 74 0a 09 09 09 73 65  ild target....se
0b60: 64 20 27 73 40 5e 24 28 54 43 4c 53 48 29 40 62  d 's@^$(TCLSH)@b
0b70: 6c 61 68 40 27 20 4d 61 6b 65 66 69 6c 65 20 3e  lah@' Makefile >
0b80: 20 4d 61 6b 65 66 69 6c 65 2e 6e 65 77 0a 09 09   Makefile.new...
0b90: 09 63 61 74 20 4d 61 6b 65 66 69 6c 65 2e 6e 65  .cat Makefile.ne
0ba0: 77 20 3e 20 4d 61 6b 65 66 69 6c 65 0a 09 09 09  w > Makefile....
0bb0: 72 6d 20 2d 66 20 4d 61 6b 65 66 69 6c 65 2e 6e  rm -f Makefile.n
0bc0: 65 77 0a 0a 09 09 09 65 63 68 6f 20 22 52 75 6e  ew.....echo "Run
0bd0: 6e 69 6e 67 3a 20 24 7b 4d 41 4b 45 3a 2d 6d 61  ning: ${MAKE:-ma
0be0: 6b 65 7d 20 69 6e 73 74 61 6c 6c 20 54 43 4c 53  ke} install TCLS
0bf0: 48 3d 5c 22 2e 2e 2f 2e 2e 2f 2e 2e 2f 2e 2e 2f  H=\"../../../../
0c00: 2e 2e 2f 2e 2e 2f 2e 2e 2f 2e 2e 2f 2e 2e 2f 2e  ../../../../../.
0c10: 2e 2f 2e 2e 2f 2e 2e 2f 2e 2e 2f 2e 2e 2f 2e 2e  ./../../../../..
0c20: 2f 2e 2e 2f 2e 2e 2f 24 28 77 68 69 63 68 20 22  /../../$(which "
0c30: 24 7b 54 43 4c 4b 49 54 3a 2d 74 63 6c 6b 69 74  ${TCLKIT:-tclkit
0c40: 7d 22 29 5c 22 22 0a 09 09 09 24 7b 4d 41 4b 45  }")\""....${MAKE
0c50: 3a 2d 6d 61 6b 65 7d 20 69 6e 73 74 61 6c 6c 20  :-make} install 
0c60: 54 43 4c 53 48 3d 22 2e 2e 2f 2e 2e 2f 2e 2e 2f  TCLSH="../../../
0c70: 2e 2e 2f 2e 2e 2f 2e 2e 2f 2e 2e 2f 2e 2e 2f 2e  ../../../../../.
0c80: 2e 2f 2e 2e 2f 2e 2e 2f 2e 2e 2f 2e 2e 2f 2e 2e  ./../../../../..
0c90: 2f 2e 2e 2f 2e 2e 2f 2e 2e 2f 24 28 77 68 69 63  /../../../$(whic
0ca0: 68 20 22 24 7b 54 43 4c 4b 49 54 3a 2d 74 63 6c  h "${TCLKIT:-tcl
0cb0: 6b 69 74 7d 22 29 22 0a 09 09 29 20 7c 7c 20 28  kit}")"...) || (
0cc0: 0a 09 09 09 23 20 4d 61 6b 65 20 69 6e 73 74 61  ....# Make insta
0cd0: 6c 6c 20 63 61 6e 20 66 61 69 6c 20 69 66 20 63  ll can fail if c
0ce0: 72 6f 73 73 2d 63 6f 6d 70 69 6c 69 6e 67 20 75  ross-compiling u
0cf0: 73 69 6e 67 20 54 63 6c 20 38 2e 35 2e 39 0a 09  sing Tcl 8.5.9..
0d00: 09 09 23 20 62 65 63 61 75 73 65 20 74 68 65 20  ..# because the 
0d10: 4d 61 6b 65 66 69 6c 65 20 63 61 6c 6c 73 20 22  Makefile calls "
0d20: 24 7b 54 43 4c 5f 45 58 45 7d 22 2e 20 20 57 65  ${TCL_EXE}".  We
0d30: 20 63 61 6e 27 74 20 73 69 6d 70 6c 79 0a 09 09   can't simply...
0d40: 09 23 20 72 65 64 65 66 69 6e 65 20 54 43 4c 5f  .# redefine TCL_
0d50: 45 58 45 20 62 65 63 61 75 73 65 20 69 74 20 61  EXE because it a
0d60: 6c 73 6f 20 75 73 65 73 20 54 43 4c 5f 45 58 45  lso uses TCL_EXE
0d70: 20 61 73 20 61 20 62 75 69 6c 64 20 74 61 72 67   as a build targ
0d80: 65 74 0a 09 09 09 73 65 64 20 27 73 40 5e 24 7b  et....sed 's@^${
0d90: 54 43 4c 5f 45 58 45 7d 40 62 6c 61 68 40 27 20  TCL_EXE}@blah@' 
0da0: 4d 61 6b 65 66 69 6c 65 20 3e 20 4d 61 6b 65 66  Makefile > Makef
0db0: 69 6c 65 2e 6e 65 77 0a 09 09 09 63 61 74 20 4d  ile.new....cat M
0dc0: 61 6b 65 66 69 6c 65 2e 6e 65 77 20 3e 20 4d 61  akefile.new > Ma
0dd0: 6b 65 66 69 6c 65 0a 09 09 09 72 6d 20 2d 66 20  kefile....rm -f 
0de0: 4d 61 6b 65 66 69 6c 65 2e 6e 65 77 0a 0a 09 09  Makefile.new....
0df0: 09 65 63 68 6f 20 22 52 75 6e 6e 69 6e 67 3a 20  .echo "Running: 
0e00: 24 7b 4d 41 4b 45 3a 2d 6d 61 6b 65 7d 20 69 6e  ${MAKE:-make} in
0e10: 73 74 61 6c 6c 20 54 43 4c 5f 45 58 45 3d 5c 22  stall TCL_EXE=\"
0e20: 2e 2e 2f 2e 2e 2f 2e 2e 2f 2e 2e 2f 2e 2e 2f 2e  ../../../../../.
0e30: 2e 2f 2e 2e 2f 2e 2e 2f 2e 2e 2f 2e 2e 2f 2e 2e  ./../../../../..
0e40: 2f 2e 2e 2f 2e 2e 2f 2e 2e 2f 2e 2e 2f 2e 2e 2f  /../../../../../
0e50: 2e 2e 2f 24 28 77 68 69 63 68 20 22 24 7b 54 43  ../$(which "${TC
0e60: 4c 4b 49 54 3a 2d 74 63 6c 6b 69 74 7d 22 29 5c  LKIT:-tclkit}")\
0e70: 22 22 0a 09 09 09 24 7b 4d 41 4b 45 3a 2d 6d 61  ""....${MAKE:-ma
0e80: 6b 65 7d 20 69 6e 73 74 61 6c 6c 20 54 43 4c 5f  ke} install TCL_
0e90: 45 58 45 3d 22 2e 2e 2f 2e 2e 2f 2e 2e 2f 2e 2e  EXE="../../../..
0ea0: 2f 2e 2e 2f 2e 2e 2f 2e 2e 2f 2e 2e 2f 2e 2e 2f  /../../../../../
0eb0: 2e 2e 2f 2e 2e 2f 2e 2e 2f 2e 2e 2f 2e 2e 2f 2e  ../../../../../.
0ec0: 2e 2f 2e 2e 2f 2e 2e 2f 24 28 77 68 69 63 68 20  ./../../$(which 
0ed0: 22 24 7b 54 43 4c 4b 49 54 3a 2d 74 63 6c 6b 69  "${TCLKIT:-tclki
0ee0: 74 7d 22 29 22 0a 09 09 29 20 7c 7c 20 65 78 69  t}")"...) || exi
0ef0: 74 20 31 0a 0a 09 09 6d 6b 64 69 72 20 22 24 7b  t 1....mkdir "${
0f00: 4f 55 54 44 49 52 7d 2f 6c 69 62 22 20 7c 7c 20  OUTDIR}/lib" || 
0f10: 65 78 69 74 20 31 0a 09 09 63 70 20 2d 72 20 22  exit 1...cp -r "
0f20: 24 7b 49 4e 53 54 44 49 52 7d 2f 6c 69 62 22 2f  ${INSTDIR}/lib"/
0f30: 2a 20 22 24 7b 4f 55 54 44 49 52 7d 2f 6c 69 62  * "${OUTDIR}/lib
0f40: 2f 22 0a 09 09 72 6d 20 2d 72 66 20 22 24 7b 4f  /"...rm -rf "${O
0f50: 55 54 44 49 52 7d 2f 6c 69 62 2f 70 6b 67 63 6f  UTDIR}/lib/pkgco
0f60: 6e 66 69 67 22 0a 09 09 72 6d 20 2d 66 20 22 24  nfig"...rm -f "$
0f70: 7b 4f 55 54 44 49 52 7d 22 2f 6c 69 62 2f 2a 20  {OUTDIR}"/lib/* 
0f80: 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f 64 65  >/dev/null 2>/de
0f90: 76 2f 6e 75 6c 6c 0a 09 09 66 69 6e 64 20 22 24  v/null...find "$
0fa0: 7b 4f 55 54 44 49 52 7d 22 20 2d 6e 61 6d 65 20  {OUTDIR}" -name 
0fb0: 27 2a 2e 61 27 20 7c 20 78 61 72 67 73 20 72 6d  '*.a' | xargs rm
0fc0: 20 2d 66 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32   -f >/dev/null 2
0fd0: 3e 2f 64 65 76 2f 6e 75 6c 6c 0a 0a 09 09 23 20  >/dev/null....# 
0fe0: 43 6c 65 61 6e 20 75 70 20 70 61 63 6b 61 67 65  Clean up package
0ff0: 73 20 74 68 61 74 20 61 72 65 20 6e 6f 74 20 6e  s that are not n
1000: 65 65 64 65 64 0a 09 09 69 66 20 5b 20 2d 6e 20  eeded...if [ -n 
1010: 22 24 7b 4b 49 54 43 52 45 41 54 4f 52 5f 4d 49  "${KITCREATOR_MI
1020: 4e 42 55 49 4c 44 7d 22 20 5d 3b 20 74 68 65 6e  NBUILD}" ]; then
1030: 0a 09 09 09 66 69 6e 64 20 22 24 7b 4f 55 54 44  ....find "${OUTD
1040: 49 52 7d 22 20 2d 6e 61 6d 65 20 22 74 63 6c 74  IR}" -name "tclt
1050: 65 73 74 2a 22 20 2d 74 79 70 65 20 64 20 7c 20  est*" -type d | 
1060: 78 61 72 67 73 20 72 6d 20 2d 72 66 0a 09 09 66  xargs rm -rf...f
1070: 69 0a 0a 09 09 23 20 43 6c 65 61 6e 20 75 70 20  i....# Clean up 
1080: 65 6e 63 6f 64 69 6e 67 73 0a 09 09 69 66 20 5b  encodings...if [
1090: 20 2d 6e 20 22 24 7b 4b 49 54 43 52 45 41 54 4f   -n "${KITCREATO
10a0: 52 5f 4d 49 4e 45 4e 43 4f 44 49 4e 47 53 7d 22  R_MINENCODINGS}"
10b0: 20 5d 3b 20 74 68 65 6e 0a 09 09 09 4b 45 45 50   ]; then....KEEP
10c0: 45 4e 43 4f 44 49 4e 47 53 3d 22 20 61 73 63 69  ENCODINGS=" asci
10d0: 69 2e 65 6e 63 20 63 70 31 32 35 32 2e 65 6e 63  i.enc cp1252.enc
10e0: 20 69 73 6f 38 38 35 39 2d 31 2e 65 6e 63 20 69   iso8859-1.enc i
10f0: 73 6f 38 38 35 39 2d 31 35 2e 65 6e 63 20 69 73  so8859-15.enc is
1100: 6f 38 38 35 39 2d 32 2e 65 6e 63 20 6b 6f 69 38  o8859-2.enc koi8
1110: 2d 72 2e 65 6e 63 20 6d 61 63 52 6f 6d 61 6e 2e  -r.enc macRoman.
1120: 65 6e 63 20 22 0a 09 09 09 65 78 70 6f 72 74 20  enc "....export 
1130: 4b 45 45 50 45 4e 43 4f 44 49 4e 47 53 0a 09 09  KEEPENCODINGS...
1140: 09 66 69 6e 64 20 22 24 7b 4f 55 54 44 49 52 7d  .find "${OUTDIR}
1150: 2f 6c 69 62 22 20 2d 6e 61 6d 65 20 27 65 6e 63  /lib" -name 'enc
1160: 6f 64 69 6e 67 27 20 2d 74 79 70 65 20 64 20 7c  oding' -type d |
1170: 20 77 68 69 6c 65 20 72 65 61 64 20 65 6e 63 64   while read encd
1180: 69 72 3b 20 64 6f 0a 09 09 09 09 28 0a 09 09 09  ir; do.....(....
1190: 09 09 63 64 20 22 24 7b 65 6e 63 64 69 72 7d 22  ..cd "${encdir}"
11a0: 20 7c 7c 20 65 78 69 74 20 31 0a 0a 09 09 09 09   || exit 1......
11b0: 09 66 6f 72 20 66 69 6c 65 20 69 6e 20 2a 3b 20  .for file in *; 
11c0: 64 6f 0a 09 09 09 09 09 09 69 66 20 65 63 68 6f  do.......if echo
11d0: 20 22 20 24 7b 4b 45 45 50 45 4e 43 4f 44 49 4e   " ${KEEPENCODIN
11e0: 47 53 7d 20 22 20 7c 20 67 72 65 70 20 22 20 24  GS} " | grep " $
11f0: 7b 66 69 6c 65 7d 20 22 20 3e 2f 64 65 76 2f 6e  {file} " >/dev/n
1200: 75 6c 6c 3b 20 74 68 65 6e 0a 09 09 09 09 09 09  ull; then.......
1210: 09 63 6f 6e 74 69 6e 75 65 0a 09 09 09 09 09 09  .continue.......
1220: 66 69 0a 0a 09 09 09 09 09 09 72 6d 20 2d 66 20  fi........rm -f 
1230: 22 24 7b 66 69 6c 65 7d 22 0a 09 09 09 09 09 64  "${file}"......d
1240: 6f 6e 65 0a 09 09 09 09 29 0a 09 09 09 64 6f 6e  one.....)....don
1250: 65 0a 09 09 66 69 0a 0a 09 09 62 72 65 61 6b 0a  e...fi....break.
1260: 09 64 6f 6e 65 0a 29 20 7c 7c 20 65 78 69 74 20  .done.) || exit 
1270: 31 0a 0a 65 78 69 74 20 30 0a                    1..exit 0.